Bug 710338 - (CVE-2011-2183) CVE-2011-2183 kernel: ksm: race between ksmd and exiting task
CVE-2011-2183 kernel: ksm: race between ksmd and exiting task
Status: CLOSED ERRATA
Product: Security Response
Classification: Other
Component: vulnerability (Show other bugs)
unspecified
All Linux
medium Severity medium
: ---
: ---
Assigned To: Red Hat Product Security
public=20110602,reported=20110602,sou...
: Security
: 719238 (view as bug list)
Depends On: 710340 710341 710988
Blocks:
  Show dependency treegraph
 
Reported: 2011-06-03 01:55 EDT by Eugene Teo (Security Response)
Modified: 2015-07-29 13:47 EDT (History)
10 users (show)

See Also:
Fixed In Version:
Doc Type: Bug Fix
Doc Text:
Story Points: ---
Clone Of:
Environment:
Last Closed: 2015-07-29 08:48:43 EDT
Type: ---
Regression: ---
Mount Type: ---
Documentation: ---
CRM:
Verified Versions:
Category: ---
oVirt Team: ---
RHEL 7.3 requirements from Atomic Host:


Attachments (Terms of Use)

  None (edit)
Description Eugene Teo (Security Response) 2011-06-03 01:55:23 EDT
Andrea Righi reported a case where an exiting task can race against ksmd.  

ksm_scan.mm_slot == the only registered mm
CPU 1 (bug program)		CPU 2 (ksmd)
 				list_empty() is false
lock
ksm_scan.mm_slot
list_del
unlock
 				slot == &ksm_mm_head (but list is now empty_)

Close this race by revalidating that the new slot is not simply the list head again.

Reproducer: http://www.spinics.net/lists/linux-mm/msg20233.html
Proposed patch: http://www.spinics.net/lists/linux-mm/msg20301.html

Acknowledgements:

Red Hat would like to thank Andrea Righi for reporting this issue.
Comment 2 Eugene Teo (Security Response) 2011-06-03 02:03:50 EDT
Statement:

This issue did not affect the versions of the Linux kernel as shipped with Red Hat Enterprise Linux 4, 5, and Red Hat Enterprise MRG do not provide support for KSM (Kernel Samepage Merging). This has been addressed in Red Hat Enterprise Linux 6 via https://rhn.redhat.com/errata/RHSA-2011-1189.html.
Comment 4 Chuck Ebbert 2011-06-23 05:24:46 EDT
Upstream commit:

 http://git.kernel.org/linus/2b472611a32a72f4a118c069c2d62a1a3f087afd
Comment 5 Eugene Teo (Security Response) 2011-07-06 04:41:00 EDT
*** Bug 719238 has been marked as a duplicate of this bug. ***
Comment 6 errata-xmlrpc 2011-08-23 10:42:24 EDT
This issue has been addressed in following products:

  Red Hat Enterprise Linux 6

Via RHSA-2011:1189 https://rhn.redhat.com/errata/RHSA-2011-1189.html
Comment 7 errata-xmlrpc 2011-09-12 15:45:36 EDT
This issue has been addressed in following products:

  MRG for RHEL-6 v.2

Via RHSA-2011:1253 https://rhn.redhat.com/errata/RHSA-2011-1253.html

Note You need to log in before you can comment on or make changes to this bug.